/*
 * SiblingInfo.cpp
 *
 *  Created on: Dec 22, 2009
 *      Author: kottlers
 */

#include "SiblingInfo.hpp"
const char*  siblinginfos_cpp_version(){return "$Revision: 1.7 $";}

//#define DBG_RET return

bool	SiblingInfo::popMessage(Message& m){
	const uint32_t mod = siblings.size();
	if(mod == 0) return false;

	const uint32_t t = last_long_pop;
	do{
		asrt(last_long_pop  < siblings.size());

		if(siblings[last_long_pop]->stream.pop(user_bit,user_id,m)){
			LOG2("Received Message from "<<last_long_pop );	return true;}

		last_long_pop = (last_long_pop + 1) % mod;
	}while(last_long_pop != t);

	return false;
}

void	SiblingInfo::sendUnitCls(const Literal& lit){
	stream.push(Message::newUnitCls(lit));
}

void	SiblingInfo::sendBinCls(const Literal& a, const Literal& b){
	stream.push(Message::newBinCls(a,b));
}

void	SiblingInfo::sendLongCls(const SharedClause* cls, const UserMask& recommended_for){
	LOG2("sibling send long cls " << ((uint64_t)cls));
	stream.push(Message::newLongCls(cls,recommended_for));
}

/*
void AbstractSiblingInfo::popLongs(vector<SharedClause*>& out){
	SharedClause* cls;
	for(uint32_t t=0;t != shared_receivers.size();++t){
		shared_queue_t& queue = *shared_receivers[t];
		while(queue.pop(user_bit,user_id,cls)){out.push_back(cls);}
	}
}*/



SiblingInfo::SiblingInfo(Satistics* s,uint32_t grp_sz,uint32_t thread_id,ImportCriteria imprt,ElimClses& eli):
	user_id				(thread_id),
	user_bit			(user_id),
	all_users_bits		((1<<grp_sz)-1),
	all_but_me_bits		(all_users_bits.mask & (~user_bit.bit_mask)),
	//aut_last			(NULL),
	//aut_next			(NULL),
	last_long_pop		(0),
	stream				(all_users_bits,user_id,grp_sz-1),
	stats				(s),
	v_info				(NULL),
	elim				(eli),
	max_lbd_gc			(3),
	import_criteria		(imprt)

	//send_cls_max_size	(max32),
	//recv_cls_max_size	(max32)
{	}

SiblingInfo::~SiblingInfo(){
	//CONSOLE("Destruct Abstract Sibling Info with id " << user_id.id << endl);
	//asrt(shared_sender.empty(user_id));}
	/*while(aut_next != NULL){
		aut_last = (AutarkyGuess*)aut_next;
		aut_next = aut_last->next;
		free(aut_last);
	}*/
}


void SiblingInfo::deleteQueueContent(){
	LOG2("Delete Longs Queue content at end with user id " << user_id.id << " and user bit " << user_bit.bit_mask);
	Message m; UserMask dummy(0);
	for(uint32_t t=0;t != siblings.size();++t){
		queue_t& queue = siblings[t]->stream;
		while(queue.pop(user_bit,user_id,m)){
			if(m.isLongCls()){
				//SharedClause::release(m.getLongCls(dummy),user_bit,"delete queue content");
				SharedClause::release(m.getLongCls(dummy),user_bit);
			}
		}
	}
}


void 	SiblingInfo::addSibling(SiblingInfo* q){
	asrt(q != this);
	asrt(q->user_id.id != user_id.id);
	siblings.push_back(q);
}

/*
void 	SiblingInfo::pushAutarkyGuess(Literal lits[], const uint32_t sz){
	asrt(sz>0);
	void* mem	= malloc(sizeof(AutarkyGuess) + sizeof(Literal)*sz);
	LOG3("Construct AutarkyGuess at" << (uint64_t)mem );
	if(mem == NULL){
		fprintf(stderr,"\nc !!!OUT OF MEMORY!!!\n");
		exit(EXIT_FAILURE);}

	AutarkyGuess* aut	= new (mem) AutarkyGuess(sz);
	for(uint32_t i=0;i!=sz;++i){aut->lits[i]=lits[i];}

	if(aut_last == NULL){asrt(aut_next==NULL);
		aut_last = aut;
		aut_next = aut;
	}else{
		aut_last->next = aut;
		aut_last = aut;
	}
}

AutarkyGuess* SiblingInfo::popAutarkyGuess(){
	if(aut_next == NULL) return NULL;

	while(aut_next != aut_last){
		if(aut_next->chkd==0) {aut_next->chkd=1; return (AutarkyGuess*)aut_next;}
		AutarkyGuess* del 	= (AutarkyGuess*)aut_next;
		aut_next			= aut_next->next;
		free(del);
	}

	return (aut_next->chkd==0) ?
			(aut_next->chkd=1,(AutarkyGuess*)aut_next) : NULL;
}
*/


TrooperSiblingInfo::TrooperSiblingInfo(Satistics* s,uint32_t grp_sz,uint32_t thread_id,const UserBit& leader_ubit,ImportCriteria imprt,ElimClses& eli)
		:SiblingInfo(s,grp_sz,thread_id,imprt,eli){}

TrooperSiblingInfo::~TrooperSiblingInfo(){}
		//CONSOLE("Destruct Trooper Sibling Info with id " << user_id.id << endl);}



void TrooperSiblingInfo::addLeader(LeaderSiblingInfo* leader){
	asrt(leader->user_id.id != user_id.id);
	siblings.push_back(leader);
	//graph_updt_receiver = &leader->graph_updt_sender;
	//asrt(!all_users_bits.hasUser(leader->user_bit));
	//all_users_bits.unsaveAddUser(leader->user_bit);
	//all_but_me_bits.unsaveAddUser(leader->user_bit);
}

void TrooperSiblingInfo::addTrooper(TrooperSiblingInfo* trooper){
	addSibling(trooper);
}

LeaderSiblingInfo::LeaderSiblingInfo(Satistics* s,uint32_t grp_sz,uint32_t thread_id,ImportCriteria imprt,ElimClses& eli)
	:SiblingInfo(s,grp_sz,thread_id,imprt,eli),
	 //graph_updt_sender(all_users_bits,user_id,grp_sz-1),
	 //last_short_pop(0),
	 active(false){
}

LeaderSiblingInfo::~LeaderSiblingInfo(){}
	//CONSOLE("Destruct Leader Sibling Info with id " << user_id.id << endl);}


Literal SiblingInfo::getMayorValue(const Variable& v){
	bool prev		= v_info->varPrevValWasTrue(v);
	int32_t bal 	= -1-siblings.size() + (2*((int32_t)prev));
	for(uint32_t i=siblings.size();i--;){
		bal += (2*((int32_t)siblings[i]->v_info->varPrevValWasTrue(v)));
	}
	return bal > 0 || (bal==0 && prev)? v.toPosLit() : v.toNegLit();
}

uint32_t LeaderSiblingInfo::getMaxLBDThreash(){
	uint32_t t = max_lbd_gc;
	for(uint32_t i=siblings.size();i--;){
		set_max_int(t,siblings[i]->max_lbd_gc);}
	return t;
}

/*
AutarkyGuess* LeaderSiblingInfo::popNextAutarkyGuess(){
	for(uint32_t i= siblings.size();i--;){
		AutarkyGuess* ret = siblings[i]->popAutarkyGuess();
		if(ret != NULL) return ret;
	}
	return popAutarkyGuess();
}*/

/*
GraphUpdateUnit& LeaderSiblingInfo::startGUSending(const UserID& who,uint16_t type){
	next_gu_unit.work_of	= who;
	next_gu_unit.type		= type;
	return next_gu_unit;
}

void LeaderSiblingInfo::sendUnitCls(const Literal& a){
	LOG_MEDIUM("Send unit clause " << (active?"active":"inactive") << a.toDIMACS());
	if(active) graph_updt_sender.push(GraphUpdate::newUnitCls(a));}

void LeaderSiblingInfo::sendGU(const GraphUpdate& gu){
	if(active) graph_updt_sender.push(gu);
}


void LeaderSiblingInfo::sendGUs(const vector<GraphUpdate>& gus){
	if(active){
		graph_updt_sender.push(gus);
		//if(gus.size()>100) CONSOLE("Push Graph Updates with size " << gus.size() << endl);
	}
}


bool LeaderSiblingInfo::popShort(ShortCls& cls,UserID& s_id){
	if(!active) return false; //for single mode
	asrt(!troopers.empty());

	const uint32_t t = last_short_pop;
	do{
		last_short_pop = (last_short_pop + 1) % troopers.size();
		//++last_short_pop; if(last_short_pop >=  short_receivers.size()) last_short_pop = 0;
		asrt(last_short_pop < troopers.size());
		short_queue_t& queue = troopers[last_short_pop]->shorts_sender;
		if(queue.pop(user_bit,cls)){
			s_id = troopers[last_short_pop]->user_id;
			LOG_MEDIUM("Received short clause from " << s_id.id );
			return true;}
	}while(last_short_pop != t);

	return false;
}

SharedClause* SiblingInfo::popLong(){
	const uint32_t mod = receivers.size();
	if(mod == 0) return NULL;

	Message m;
	const uint32_t t = last_long_pop;
	do{
		last_long_pop = (last_long_pop + 1) % mod;
		asrt(last_long_pop  < receivers.size());

		if(receivers[last_long_pop]->pop(user_bit,user_id,m) && m.isLongCls()){
			LOG_MEDIUM("Received shared clause from "<<last_long_pop );	return m.getLongCls();}
	}while(last_long_pop != t);

	return NULL;

}*/

void LeaderSiblingInfo::printParaProgress(){
	stats->printParaProgress(true,siblings.empty());
	for(uint32_t i=0;i!=siblings.size();++i){
		siblings[i]->stats->printParaProgress(false,i==siblings.size()-1);
	}
}




void LeaderSiblingInfo::deleteQueueContent(){
	LOG2("Delete Leader Queue content at end");
	SiblingInfo::deleteQueueContent();
	/*ShortCls dummy;
	for(uint32_t t=0;t != troopers.size();++t){
		short_queue_t& queue = troopers[t]->shorts_sender;
		asrt(queue.owner_id != user_id);
		while(queue.pop(user_bit,dummy)){ asrt(true);}
		//asrt(queue.readerActual());
	}*/
}


void LeaderSiblingInfo::addTrooper(TrooperSiblingInfo* trooper){
	asrt(trooper!=NULL);asrt(trooper->user_id.id != user_id.id);
	siblings		.push_back(trooper);
	/*
	troopers		.push_back(trooper);
	asrt(trooper->user_id.id == troopers.size());*/
	//asrt(!all_users_bits.hasUser(trooper->user_bit));
	//all_users_bits.unsaveAddUser(trooper->user_bit);
	//all_but_me_bits.unsaveAddUser(trooper->user_bit);
}


